"Filed out from Dolphin Smalltalk/Version 2.1"!

Object subclass: #Banco
	instanceVariableNames: 'cuentas clientes'
	classVariableNames: ''
	poolDictionaries: ''!

Banco class instanceVariableNames: ''!

Banco comment: ''!

!Banco categoriesForClass!No category! !

!Banco methodsFor!

"Especificamos el dni de un cliente y borramos su ficha y sus cuentas"
borrarCliente: dni
	|seguir num total|
	num := 1.
	total := cuentas size.
	(num > total) ifTrue: [seguir := false.]
			    ifFalse: [seguir := true.].
	
	[seguir ] whileTrue: 
		[ ((((cuentas at: num) getTitular) getDNI)  = dni)
			ifTrue: [cuentas removeAtIndex: num. total:=total-1. (num > total) ifTrue: [seguir:=false].]
			ifFalse: [num := num+1. (num > total) ifTrue: [seguir:=false].]
		 ].
	num := 1.
	total := clientes size.
	(num > total) ifTrue: [seguir := false.]
	 		    ifFalse: [seguir := true.].
	[seguir] whileTrue: 
		[ (((clientes at: num) getDNI)  = dni)
			ifTrue: [clientes removeAtIndex: num. seguir := false.]
			ifFalse: [num := num+1. (num > total) ifTrue: [seguir:=false] ]
		 ].!

"Especificamos el id de una cuenta para borrarla"
borrarCuenta: id
	|seguir num total|
	num := 1.
	total := cuentas size.
	(num > total) ifTrue: [seguir := false.]
			    ifFalse: [seguir := true.].
	
	[seguir ] whileTrue: 
		[ (((cuentas at: num) getID)  = id)
			ifTrue: [cuentas removeAtIndex: num. seguir:=false.]
			ifFalse: [num := num+1. (num > total) ifTrue: [seguir:=false].]
		 ].!

"Constructor, debe ser llamado antes de utilizar la clase"
ini
	cuentas := LinkedList new. 
	clientes := LinkedList new.
!

"Aadimos un cliente, nos aseguramos antes de que no exista otro cliente con el mismo DNI"
insertarCliente:cl
	|seguir num total dni|
	dni := cl getDNI.
	num := 1.
	total := clientes size.
	(num > total) ifTrue: [seguir := false.]
	 		    ifFalse: [seguir := true.].
	[seguir] whileTrue: 
		[ (((clientes at: num) getDNI)  = dni)
			ifTrue: [^false.]
			ifFalse: [num := num+1. (num > total) ifTrue: [seguir:=false] ]
		 ].
	clientes addLast: cl.
	^true!

"Aadimos una cuenta, nos aseguramos antes que no exista otra cuenta con el mismo ID"
insertarCuenta: a
	|seguir num total id|
	id := a getID.
	num := 1.
	total := cuentas size.
	(num > total) ifTrue: [seguir := false.]
			    ifFalse: [seguir := true.].
	
	[seguir ] whileTrue: 
		[ (((cuentas at: num) getID)  = id)
			ifTrue: [^false.]
			ifFalse: [num := num+1. (num > total) ifTrue: [seguir:=false].]
		 ].
	cuentas addLast: a.
	^true!

"Devuelve el listado de clientes, nos sirve para comprobar en el test que las operaciones sobre el banco funcionan correctamente."
listadoClientes
	^clientes!

"Devuelve el listado de cuentas, nos sirve para comprobar en el test que las operaciones sobre el banco funcionan correctamente."
listadoCuentas
	^cuentas!

"Devuelve el numero total de clientes que tenemos"
numClientes
	^clientes size!

"Devuelve el numero total de cuentas que tenemos"
numCuentas
	^cuentas size!

"Realiza la revision sobre todas las cuentas que tengamos"
revision
	1 to: cuentas size do: 
		[ :i |  (cuentas at: i) revision].! !

!Banco categoriesFor: #borrarCliente:!no category! !
!Banco categoriesFor: #borrarCuenta:!no category! !
!Banco categoriesFor: #ini!no category! !
!Banco categoriesFor: #insertarCliente:!no category! !
!Banco categoriesFor: #insertarCuenta:!no category! !
!Banco categoriesFor: #listadoClientes!no category! !
!Banco categoriesFor: #listadoCuentas!no category! !
!Banco categoriesFor: #numClientes!no category! !
!Banco categoriesFor: #numCuentas!no category! !
!Banco categoriesFor: #revision!no category! !

